const coral = @import("coral");

pub const Item = struct {
	transform: Transform,

	options: union (enum) {
		sprite: struct {

		},
	},
};

pub const Transform = extern struct {
	x: coral.math.Vector2,
	y: coral.math.Vector2,
	origin: coral.math.Vector2,

	pub const identity = Transform{
		.x = .{1, 0},
		.y = .{0, 1},
		.origin = .{0, 0},
	};
};
